Subject: Problems with Static build under LInux

Description: Static build (part of make distrib) leads to the following error message under Gentoo





<pre>


/usr/lib/gcc/i686-pc-linux-gnu/4.4.3/../../../../i686-pc-linux-gnu/bin/ld: dynamic STT_GNU_IFUNC symbol 

`strcmp' with pointer equality in `/usr/lib/gcc/i686-pc-linux-gnu/4.4.3/../../../libc.a(strcmp.o)' can not be used 

when making an executable; recompile with -fPIE and relink with -pie


collect2: ld returned 1 exit status


File "caml_startup", line 1, characters 0-1:


Error: Error during linking


</pre>


History

03/03/2011 12:10 am - Alexander Heußner

- Status changed from New to Resolved

- Priority changed from Normal to Low

- % Done changed from 0 to 100

uncommented static building 





<pre>


--- Makefile    2011-02-17 03:43:59.000000000 +0100


+++ Makefile.orig       2011-02-17 03:43:35.000000000 +0100


@@ -80,6 +80,7 @@


        os=$$(uname -s);\


        arch=$$($(OCAMLBUILD) -build-dir $(BUILDDIR) -quiet __show_architecture__);\


        today=$$(date '+%C%y%m%d');\


+       test "$$os" != "Linux" || $(MAKE) native.static;\


        example_dir='examples/scm';\


        $(GNUTAR) -jcvf mcscm_$${os}_$${arch}_$${today}.tar.bz2\


            --transform 's,^,mcscm/,'\


</pre>

03/03/2011 12:34 am - Alexander Heußner

seems a problem with ocaml under Gentoo as was able to build 64bit variant under other linux.





nevertheless, ignore for the moment the static build

03/03/2011 12:46 pm - Alexander Heußner

- Status changed from Resolved to Closed

Alexander Heußner wrote:


> seems a problem with ocaml under Gentoo as was able to build 64bit variant under other linux.





additional testing revealed that it was a Linux-distribution problem and not a mcscm problem, 


the only interesting message was


<pre>


unix.c:(.text+0x232): warning: Using 'dlopen' in statically linked applications requires at runtime the shared libraries from the glibc version used for 
linking


</pre>


but it seems to not effect our static build (tested compilation/running on different plattforms).





thus, the Makefile allows again static building under linux


04/08/2011 01:29 pm - Grégoire Sutre

- Target version set to 1.0
